#ifndef TASK_H
#define TASK_H

#include <stdint.h>

extern void initTasking();
 
typedef struct {
    uint32_t eax, ebx, ecx, edx, esi, edi, esp, ebp, eip, eflags, cr3;
} Registers;
 
typedef struct Task {
    Registers registers;
    struct Task *nextTask; // linked list of tasks that need to be done
} Task;
 
extern void initTasking();
extern void createTask(Task *task, uint32_t mainFunction, uint32_t flags, uint32_t *pagedir);
 
extern void yield();
extern void yields(); // yield, but first schedule the currently running task
extern void switchTask(Registers *old, Registers *new);
extern void schedule(Task* task);

extern void setRunningTask(Task* task);

#endif